include \masm32\include\masm32rt.inc

EnumCrt macro name, init
LOCAL hasPlus
  ceNAME equ name		; we start a new enumeration
  ceCount = 0
  ceOffset equ <>
  ifnb <init>
	hasPlus INSTR <init>, <+>
	if hasPlus
		ceOffset    SubStr <init>, 1, hasPlus
		ceCount = @SubStr(<init>, hasPlus + 1)
	else
		ceCount = init
	endif
  endif
ENDM

EnumAdd macro name, init
	% @CatStr(&ceNAME&, <_>, <name>, < = >, &ceOffset&, %ceCount)
	ceCount = ceCount + 1
ENDM

.code
start:
	; create a new enumeration...
	EnumCrt	ACCESS_MODE		; starting with zero (0 or no argument: start with zero)
	EnumAdd	NOT_USED_ACCESS	; ACCESS_MODE_NOT_USED_ACCESS = 0
	EnumAdd	GRANT_ACCESS
	EnumAdd	SET_ACCESS
	EnumAdd	DENY_ACCESS
	EnumAdd	REVOKE_ACCESS
	EnumAdd	SET_AUDIT_SUCCESS
	EnumAdd	SET_AUDIT_FAILURE
	print str$(ACCESS_MODE_SET_ACCESS), 9, "ACCESS_MODE_SET_ACCESS", 13, 10
	print str$(ACCESS_MODE_SET_AUDIT_FAILURE), 9, "ACCESS_MODE_SET_AUDIT_FAILURE", 13, 10, 10

	; create a new enumeration starting with...
	EnumCrt	CURLFORM, WM_USER+100		; WM_USER+100
;	EnumCrt	CURLFORM, 100	; 100
;	EnumCrt	CURLFORM		; zero
	EnumAdd	COPYNAME
	EnumAdd	PTRNAME
	EnumAdd	NAMELENGTH
	EnumAdd	COPYCONTENTS
	EnumAdd	PTRCONTENTS
	EnumAdd	CONTENTSLENGTH
	EnumAdd	FILECONTENT
	EnumAdd	ARRAY
	EnumAdd	OBSOLETE
	EnumAdd	FILE
	EnumAdd	BUFFER
	EnumAdd	BUFFERPTR
	EnumAdd	BUFFERLENGTH
	EnumAdd	CONTENTTYPE
	EnumAdd	CONTENTHEADER
	EnumAdd	FILENAME
	EnumAdd	END
	EnumAdd	OBSOLETE2
	EnumAdd	STREAM
	print str$(CURLFORM_COPYNAME), 9, "CURLFORM_COPYNAME", 13, 10
	print str$(CURLFORM_NAMELENGTH), 9, "CURLFORM_NAMELENGTH", 13, 10
	print str$(CURLFORM_BUFFER), 9, "CURLFORM_BUFFER", 13, 10
	print str$(CURLFORM_STREAM), 9, "CURLFORM_STREAM", 13, 10

	getkey
	exit

end start
OPT_Wait	0
OPT_Tmp2Asm	1
